上一篇介绍了“GDK7+NanoCode调试学习系列3--中断Linux驱动i915.ko”本篇继续学习：
- 搭建使用Windbg通过NET来调试windows内核的环境；
- 同时，搭建使用NanoCode通过DCI来调试windows内核的环境；

本篇没有具体的调试驱动步骤，主要搭建调试环境。

## 准备工作：
1. 查看目标GDK7是否支持NET调试

	查看目标机的“系统信息”和对应的网卡设备的“硬件Id”，然后在 [Supported Ethernet NICs for Network Kernel Debugging in Windows 10, Version 1909 (19H2) Build 18363 - Windows drivers | Microsoft Learn](https://docs.microsoft.com/en-us/windows-hardware/drivers/debugger/supported-ethernet-nics-for-network-kernel-debugging-in-windows-10-1909 "Supported Ethernet NICs for Network Kernel Debugging in Windows 10, Version 1909 (19H2) Build 18363 - Windows drivers | Microsoft Learn") 上查询，说明支持NET调试。

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_9eeb675a01673daa6c7fcb9c7b198890_r.png)

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_93e8a07cacd9b0650c49ca7e4885f526_r.png)

2. 设置目标机GDK7的调试选项

	可根据此链接（Set Up KDNET Network Kernel Debugging Manually - Windows drivers | Microsoft Learn）来设置，如下：
    - 目标机GDK7和调试主机在同一个网络下；
    - 查看调试主机的IPv4地址，必须是IPv4；
    - 目标机GDK7管理员打开cmd.exe，执行如下指令，同时记下生成的key；
bcdedit /debug on
bcdedit /dbgsettings net hostip:w.x.y.z port:n

	注：hostip是刚刚查询到的调试主机的IPv4

	注：port是调试主机使用的连接端口号，使用一个未被使用的，推荐50000 - 50039，使用netstat -ano | findstr 50000来查询

	执行完，会输出一个key，格式为x.x.x.x；官方推荐使用自动生成的key，但是也可以自定义，如下：
bcdedit /dbgsettings net hostip:w.x.y.z port:n key:x.x.x.x

    - （可选）如果目标机有多个网络适配器，需要设置使用哪个网络适配器来调试，在网络适配器-属性-常规下看到b.d.f（总线.设备.功能），然后执行：
bcdedit /set "{dbgsettings}" busparams b.d.f
    - 至此，目标机设置结束，重启目标机。重启后，看设备管理器-网络适配器多了一个：
	
![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_24f33753e79266e049d5ca9102c9ec86_r.png)

## 开始调试：
1. 使用Windbg来连接调试

	启动Windbg，选择内核调试-NET，填入上面设置的port和生成的key，确定执行；

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_b0b57c3b6d8734994bbfbe9d58a8d580_r.png)

	不久，输出连接信息；

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_d1cc61b35049415f62016a9e2bccb32a_r.png)

	然后按下"Break"，成功断下；

	然后执行.reload, lm可以看到很多模块；

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_29b34249f3cc1c3bc700ac770139e967_r.png)

	之后，可以使用命令来调试了~~~

2. 使用NanoCode连接目标机

	在Windbg下执行g重启跑来目标机。下面继续在Windbg调试内核的情况下，使用NanoCode也连接调试目标机。

	启动NanoCode,选择“去调试”-内核调试：

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_4f858303da4f56a348c9c0d856930ca2_r.png)

	点击确定之后，会自动连接并中断目标机；

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_f76c1ad6b3449f9e58b9095d26feb716_r.png)

	执行.reload, lm也可以看到更多的模块了；

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_8e35340d3ee5a3c02c4a89607a7ef2df_r.png)

	此时，我们可以查看一下kdnic的符号，执行x kdnic!*，输出很多符号。

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_caaff2823a26ab213fa06f726b98fbae_r.png)

3. Windbg和NanoCode双管齐下

	至此，Windbg和NanoCode已经同时连接到一个目标机GDK7下，可以相互配合地调试了~

![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_cb2137e2a775a2a43da5d6c16bd9ea91_r.png)

## 总结：

1. 主要搭建使用Windbg和NanoCode同时调试一个目标机Windows的环境；

2. 待续。。。