### 教程概述
本教程旨在指导用户如何使用 WinDbg 通过串口连接方式来调试 GDK7（ Windows 系统）。

### 准备工具
- **目标机**：GDK7（被调试设备）。
- **主机**：另一台GDK7 配置为调试器的计算机，用于执行 WinDbg 软件。
- **串口线**：将两个机器进行连接

### 配置步骤

#### 1. 配置目标机
- **开启管理员权限的命令行**：在目标机上，以管理员身份打开命令提示符，并依次执行下面命令。
- **设置调试串口**：
  ```bash
 bcdedit /dbgsettings serial debugport:1 baudrate:115200
  ```
- **激活调试模式**：
  ```bash
  bcdedit /debug on
  ```
- **开启引导调试**：
  ```bash
  bcdedit /bootdebug on
  ```
- **允许测试签名**：(可选项)
  ```bash
  bcdedit /set testsigning yes
  ```

#### 2. 连接两台机器
- 使用串口线将两台设备的 COM1 端口相连接。

#### 3. 配置主机上的 WinDbg
- **启动 WinDbg**：在主机上，打开 WinDbg。
- **选择内核调试**：在 WinDbg 中选择 `File` > `Kernel Debug`。
- **设置串口配置**：
  - 在弹出的窗口中，选择 `COM` 选项卡。
  - 在 `Port` 字段中输入 `1`，在 `Baud Rate` 字段中输入 `115200`。

### 开始调试
配置完毕后，重启目标机，主机上的 WinDbg 将开始接收来自目标机的调试数据。此时，您可以使用 WinDbg 的功能来观察和控制目标机的运行状态，进行断点设置，以及执行其他调试任务。
如下图所示：
![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_fcb5fce936ec3505f0bbbd3dafed14b7_r.png)